/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of iASLzLurBZ.aml, Sat Feb 29 09:31:32 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000620 (1568)
 *     Revision         0x02
 *     Checksum         0x37
 *     OEM ID           "NICO"
 *     OEM Table ID     "TBOLT3"
 *     OEM Revision     0x00000000 (0)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20190215 (538509845)
 */
DefinitionBlock ("", "SSDT", 2, "NICO", "TBOLT3", 0x00000000)
{
    External (_SB_.PCI0.BR1A, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.BR1A.D07C, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.BR1A.H000, DeviceObj)    // (from opcode)
    External (DTGP, MethodObj)    // 5 Arguments (from opcode)

    Scope (\_SB.PCI0.BR1A)
    {
        Scope (H000)
        {
            Name (_STA, Zero)  // _STA: Status
        }

        Scope (D07C)
        {
            Name (_STA, Zero)  // _STA: Status
        }

        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
        {
            Return (Zero)
        }

        Device (UPSB)
        {
            Name (_ADR, Zero)  // _ADR: Address
            OperationRegion (A1E0, PCI_Config, Zero, 0x40)
            Field (A1E0, ByteAcc, NoLock, Preserve)
            {
                AVND,   32, 
                BMIE,   3, 
                Offset (0x18), 
                PRIB,   8, 
                SECB,   8, 
                SUBB,   8, 
                Offset (0x1E), 
                    ,   13, 
                MABT,   1
            }

            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (Package (0x02)
                {
                    0x69, 
                    0x03
                })
            }

            Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
            {
                Return (SECB)
            }
   
			Method (_STA, 0, NotSerialized)  // _STA: Status
			{
				Return (0x0F)
			}

			Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
			{
				Return (Zero)
			}

			Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
			{
				Store (Package (0x08)
					{
						"AAPL,slot-name", 
						Buffer (0x09)
						{
							"Built In"
						}, 

						"built-in", 
						Buffer (One)
						{
							 0x00                                           
						}, 

						"PCIHotplugCapable", 
						One, 
						"PCI-Thunderbolt", 
						One
					}, Local0)
				DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
				Return (Local0)
			}

			Device (DSB0)
			{
				Name (_ADR, Zero)  // _ADR: Address
				Method (_STA, 0, NotSerialized)  // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
				{
					Return (Zero)
				}

				Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
				{
					Store (Package (0x06)
						{
							"AAPL,slot-name", 
							Buffer (0x09)
							{
								"Built In"
							}, 

							"built-in", 
							Buffer (One)
							{
								 0x00                                           
							}, 

							"PCIHotplugCapable", 
							One
						}, Local0)
					DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
					Return (Local0)
				}

				Device (NHI0)
				{
					Name (_ADR, Zero)  // _ADR: Address
					Name (_STR, Unicode ("Thunderbolt"))  // _STR: Description String
					Method (_STA, 0, NotSerialized)  // _STA: Status
					{
						Return (0x0F)
					}

					Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
					{
						Return (Zero)
					}

					Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
					{
						Store (Package (0x0F)
							{
								"AAPL,slot-name", 
								Buffer (0x07)
								{
									"Slot-4"
								}, 

								"name", 
								Buffer (0x23)
								{
									"Titan Ridge Thunderbolt Controller"
								}, 

								"model", 
								Buffer (0x2C)
								{
									"Intel JHL7540 Titan Ridge Thunderbolt 3 NHI"
								}, 

								"device_type", 
								Buffer (0x17)
								{
									"Thunderbolt-Controller"
								}, 
/*
								"ThunderboltDROM", 
								Buffer (0x65)
								{
									0x11, 0x02, 0x65, 0xBA, 0x7C, 0x7F, 0x59, 0x00,
									0x00, 0x2D, 0xEA, 0x01, 0xBD, 0x01, 0x58, 0x00,
									0x01, 0x00, 0x10, 0x00, 0x01, 0x00, 0x08, 0x81,
									0x82, 0x02, 0x82, 0x00, 0x00, 0x00, 0x08, 0x82,
									0x92, 0x01, 0x82, 0x00, 0x00, 0x00, 0x08, 0x83,
									0x82, 0x04, 0x82, 0x01, 0x00, 0x00, 0x08, 0x84,
									0x92, 0x03, 0x82, 0x01, 0x00, 0x00, 0x05, 0x85,
									0x09, 0x01, 0x00, 0x05, 0x86, 0x09, 0x01, 0x00,
									0x02, 0x87, 0x03, 0x88, 0x20, 0x03, 0x89, 0x80,
									0x02, 0xCA, 0x02, 0xCB, 0x0D, 0x01, 0x41, 0x70,
									0x70, 0x6C, 0x65, 0x20, 0x49, 0x6E, 0x63, 0x2E,
									0x00, 0x0C, 0x02, 0x4D, 0x61, 0x63, 0x69, 0x6E,
									0x74, 0x6F, 0x73, 0x68, 0x00                   
								}, 


                                    "ThunderboltDROM", 
                                    Buffer (0x73)
                                    {
                                        0x10, 0x00, 0x81, 0x59, 0x29, 0x57, 0x4e, 0x00,
                                        0x00, 0x11, 0x11, 0x11, 0x11, 0x01, 0x58, 0x00,
                                        0x01, 0x00, 0x0d, 0x00, 0x01, 0x00, 0x08, 0x81,
                                        0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,
                                        0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,
                                        0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,
                                        0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x05, 0x85,
                                        0x50, 0x00, 0x00, 0x05, 0x86, 0x50, 0x00, 0x00,
                                        0x02, 0x87, 0x0B, 0x88, 0x20, 0x01, 0x00, 0x64,
                                        0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x89, 0x80,
                                        0x05, 0x8A, 0x50, 0x40, 0x00, 0x05, 0x8B, 0x50,
                                        0x40, 0x00, 0x0D, 0x01, 0x41, 0x70, 0x70, 0x6C,
                                        0x65, 0x20, 0x49, 0x6E, 0x63, 0x2E, 0x00, 0x0C,
                                        0x02, 0x4D, 0x61, 0x63, 0x69, 0x6E, 0x74, 0x6F,
                                        0x73, 0x68, 0x00
                                    },
*/
// GC-Alpine Ridge - 1
/*
"ThunderboltDROM",
Buffer (0x73)
{
0x88, 0x00, 0x11, 0x11, 0x11, 0x11, 0x11, 0x00,
0x00, 0x80, 0x59, 0xEB, 0x58, 0x01, 0x58, 0x00,
0x01, 0x00, 0x0d, 0x00, 0x01, 0x00, 0x08, 0x81,
0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,
0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,
0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,
0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x02, 0x85,
0x0B, 0x86, 0x60, 0x01, 0x00, 0x64, 0x00, 0x00,
0x00, 0x00, 0x00, 0x03, 0x87, 0x80, 0x05, 0x88,
0x00, 0x00, 0x00, 0x02, 0xC9, 0x05, 0x8A, 0x50,
0x00, 0x00, 0x02, 0xCB, 0x02, 0xCC, 0x0B, 0x01,
0x47, 0x49, 0x47, 0x41, 0x42, 0x59, 0x54, 0x45,
0x00, 0x12, 0x02, 0x47, 0x43, 0x2D, 0x41, 0x4C,
0x50, 0x49, 0x4E, 0x45, 0x20, 0x52, 0x49, 0x44,
0x47, 0x45, 0x00
},
*/

// GC-Alpine Ridge - 2 (good)
/*
"ThunderboltDROM",
Buffer (0x77)
{
0x88, 0x00, 0x11, 0x11, 0x11, 0x11, 0x11, 0x00,
0x00, 0x1F, 0x40, 0xDF, 0x8A, 0x01, 0x58, 0x00,
0x01, 0x00, 0x0d, 0x00, 0x01, 0x00, 0x08, 0x81,
0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,
0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,
0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,
0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x02, 0x85,
0x0B, 0x86, 0x20, 0x01, 0x00, 0x64, 0x00, 0x00,
0x00, 0x00, 0x00, 0x03, 0x87, 0x80, 0x05, 0x88,
0x50, 0x40, 0x00, 0x05, 0x89, 0x50, 0x00, 0x00,
0x05, 0x8A, 0x50, 0x00, 0x00, 0x05, 0x8B, 0x50,
0x40, 0x00, 0x0B, 0x01, 0x47, 0x49, 0x47, 0x41,
0x42, 0x59, 0x54, 0x45, 0x00, 0x12, 0x02, 0x47,
0x43, 0x2D, 0x41, 0x4C, 0x50, 0x49, 0x4E, 0x45,
0x20, 0x52, 0x49, 0x44, 0x47, 0x45, 0x00
},
*/

// Designare Z390
/*
"ThunderboltDROM",
Buffer (0x76)
{
0xD5, 0x00, 0x21, 0x23, 0x54, 0xAE, 0xD8, 0x00,
0x00, 0xDF, 0x1C, 0x09, 0x05, 0x01, 0x58, 0x00,
0x01, 0x00, 0x0d, 0x00, 0x01, 0x00, 0x08, 0x81,
0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,
0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,
0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,
0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x05, 0x85,
0x50, 0x00, 0x00, 0x05, 0x86, 0x50, 0x00, 0x00,
0x02, 0x87, 0x0B, 0x88, 0x20, 0x01, 0x00, 0x64,
0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x89, 0x80,
0x05, 0x8A, 0x50, 0x40, 0x00, 0x05, 0x8B, 0x50,
0x40, 0x00, 0x0B, 0x01, 0x47, 0x49, 0x47, 0x41,
0x42, 0x59, 0x54, 0x45, 0x00, 0x11, 0x02, 0x5A,
0x33, 0x39, 0x30, 0x20, 0x44, 0x45, 0x53, 0x49,
0x47, 0x4E, 0x41, 0x52, 0x45, 0x00
},
*/

// For X570 Creator
/*
                                "ThunderboltDROM", 
                                Buffer (0x72)
                                {
                                    0x88, 0x00, 0x11, 0x11, 0x11, 0x11, 0x11, 0x00,  // ........
                                    0x00, 0xF1, 0x95, 0x3A, 0x63, 0x01, 0x65, 0x00,  // ..0HS.e.
                                    0x86, 0x80, 0x34, 0x12, 0x01, 0x01, 0x08, 0x81,  // ..4.....
                                    0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,  // ........
                                    0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,  // ........
                                    0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,  // ........
                                    0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x05, 0x85,  // ........
                                    0x50, 0x00, 0x00, 0x05, 0x86, 0x50, 0x00, 0x00,  // P....P..
                                    0x02, 0xCB, 0x0B, 0x88, 0x20, 0x01, 0x00, 0x64,  // .... ..d
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x89, 0x80,  // ........
                                    0x05, 0x8A, 0x50, 0x00, 0x00, 0x05, 0x8B, 0x50,  // ..P....P
                                    0x00, 0x00, 0x09, 0x01, 0x41, 0x53, 0x52, 0x4F,  // ....ASRO
                                    0x43, 0x4B, 0x00, 0x0F, 0x02, 0x58, 0x35, 0x37,  // CK...X57
                                    0x30, 0x20, 0x43, 0x72, 0x65, 0x61, 0x74, 0x6F,  // 0 Creato
                                    0x72, 0x00                                       // r.
                                }, 
*/

// GC-Titan Ridge

"ThunderboltDROM",
Buffer (0x76)
{
0x71, 0x00, 0x32, 0xFA, 0xCC, 0x85, 0xA3, 0x00,
0x00, 0xbf, 0x6b, 0xda, 0x44, 0x01, 0x58, 0x00,
0x01, 0x00, 0x0d, 0x00, 0x01, 0x08, 0x08, 0x81,
0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,
0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,
0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,
0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x05, 0x85,
0x50, 0x00, 0x00, 0x05, 0x86, 0x50, 0x00, 0x00,
0x02, 0x87, 0x0B, 0x88, 0x20, 0x01, 0x00, 0x64,
0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x89, 0x80,
0x05, 0x8A, 0x50, 0x40, 0x00, 0x05, 0x8B, 0x50,
0x40, 0x00, 0x0B, 0x01, 0x47, 0x49, 0x47, 0x41,
0x42, 0x59, 0x54, 0x45, 0x00, 0x11, 0x02, 0x47,
0x43, 0x2D, 0x54, 0x49, 0x54, 0x41, 0x4E, 0x20,
0x52, 0x49, 0x44, 0x47, 0x45, 0x00
},

/*
                                "ThunderboltDROM", 
                                Buffer (0x71)
                                {
                                    0x88, 0x00, 0x11, 0x11, 0x11, 0x11, 0x11, 0x00,  // ........
                                    0x00, 0x87, 0x0A, 0x97, 0x5E, 0x01, 0x58, 0x00,  // ....^.X.
                                    0x01, 0x00, 0x0D, 0x00, 0x01, 0x00, 0x08, 0x81,  // ........
                                    0x80, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x82,  // ........
                                    0x90, 0x01, 0x80, 0x00, 0x00, 0x00, 0x08, 0x83,  // ........
                                    0x80, 0x04, 0x80, 0x01, 0x00, 0x00, 0x08, 0x84,  // ........
                                    0x90, 0x03, 0x80, 0x01, 0x00, 0x00, 0x02, 0x85,  // ........
                                    0x0B, 0x86, 0x20, 0x01, 0x00, 0x64, 0x00, 0x00,  // .. ..d..
                                    0x00, 0x00, 0x00, 0x03, 0x87, 0x80, 0x05, 0x88,  // ........
                                    0x50, 0x00, 0x00, 0x05, 0x89, 0x50, 0x00, 0x00,  // P....P..
                                    0x05, 0x8A, 0x50, 0x00, 0x00, 0x05, 0x8B, 0x50,  // ..P....P
                                    0x00, 0x00, 0x08, 0x01, 0x49, 0x6E, 0x74, 0x65,  // ....Inte
                                    0x6C, 0x00, 0x0F, 0x02, 0x48, 0x61, 0x64, 0x65,  // l...Hade
                                    0x73, 0x20, 0x43, 0x61, 0x6E, 0x79, 0x6F, 0x6E,  // s Canyon
                                    0x00                                             // .
                                }, 
*/
								"linkDetails", 
								Buffer (0x08)
								{
									 0x08, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00 
								}, 

								"power-save", 
								One, 
								Buffer (One)
								{
									 0x00                                           
								}
							}, Local0)
						DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
						Return (Local0)
					}
				}
			}

			Device (DSB1)
			{
				Name (_ADR, 0x00010000)  // _ADR: Address
				Method (_STA, 0, NotSerialized)  // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
				{
					Return (Zero)
				}

				Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
				{
					Store (Package (0x06)
						{
							"AAPL,slot-name", 
							Buffer (0x09)
							{
								"Built In"
							}, 

							"built-in", 
							Buffer (One)
							{
								 0x00                                           
							}, 

							"PCIHotplugCapable", 
							One
						}, Local0)
					DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
					Return (Local0)
				}
			}

			Device (DSB2)
			{
				Name (_ADR, 0x00020000)  // _ADR: Address
				Method (_STA, 0, NotSerialized)  // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
				{
					Return (Zero)
				}

				Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
				{
					Store (Package (0x06)
						{
							"AAPL,slot-name", 
							Buffer (0x09)
							{
								"Built In"
							}, 

							"built-in", 
							Buffer (One)
							{
								 0x00                                           
							}, 

							"PCIHotplugCapable", 
							One
						}, Local0)
					DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
					Return (Local0)
				}

				Device (XHC2)
				{
					Name (_ADR, Zero)  // _ADR: Address
					Method (_STA, 0, NotSerialized)  // _STA: Status
					{
						Return (0x0F)
					}

					Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
					{
						Return (Zero)
					}

					Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
					{
						Store (Package (0x18)
							{
								"AAPL,slot-name", 
								Buffer (0x07)
								{
									"Slot-4"
								}, 

								"built-in", 
								Buffer (One)
								{
									 0x00                                           
								}, 

								"name", 
								Buffer (0x1F)
								{
									"Titan Ridge USB 3.1 Controller"
								}, 

								"model", 
								Buffer (0x22)
								{
									"Intel JHL7540 Titan Ridge USB 3.1"
								}, 

								"device_type", 
								Buffer (0x1F)
								{
									"USB eXtensible Host-Controller"
								}, 

								"AAPL,current-available", 
								0x0834, 
								"AAPL,current-extra", 
								0x0A8C, 
								"AAPL,current-in-sleep", 
								0x0A8C, 
								"AAPL,max-port-current-in-sleep", 
								0x0834, 
								"AAPL,device-internal", 
								Zero, 
								"AAPL,root-hub-depth", 
								0x1A, 
								"AAPL,XHC-clock-id", 
								One
							}, Local0)
						DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
						Return (Local0)
					}
				}
			}

			Device (DSB4)
			{
				Name (_ADR, 0x00040000)  // _ADR: Address
				Method (_STA, 0, NotSerialized)  // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
				{
					Return (Zero)
				}

				Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
				{
					Store (Package (0x06)
						{
							"AAPL,slot-name", 
							Buffer (0x09)
							{
								"Built In"
							}, 

							"built-in", 
							Buffer (One)
							{
								 0x00                                           
							}, 

							"PCIHotplugCapable", 
							One
						}, Local0)
					DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
					Return (Local0)
				}
			}
		}
    }
}

